{
 Example #3 - "Mapping of JSS output functions to your own."
 (c) Copyright 1999 Tecnic Software productions (TNSP)
 Programmed and designed by Matti "ccr" Hamalainen

 NOTICE! THIS EXAMPLE PROGRAM IS LICENSED UNDER
 "JSS EXAMPLE PROGRAM LICENSE" WHICH CAN BE FOUND FROM
 README.TXT FILE UNDER THIS (EXAMPLE PROGRAMS) DIRECTORY.

 DESCRIPTION:

 This simple sourcecode is NOT meant to DIRECTLY usable at all.
 It just shows you how to assign the JSS's error, warning and
 message output into your own functions...

 TIPS AND HINTS:
 It is not always necessary or appropriate to show the warning/error
 or other message in the xxxProc() itself, but you can make a table
 (list) of messages and save them there in the proc. And when a
 appropriate moment occurs, you show them to the user.

 PS. It is not wise to bugger the user with constant flow of
     message boxes with "OK"/"Cancel" button(s). I would recommend
     that you just collect the messages to a list (as said before)
     and show them after the JSS routine has exited.
}
program Example3;

 uses BaseAPI, JSS;


procedure my_WarningProc(AFrom, AMessage:String);
begin
 writeln('JSS Warning: ', AFrom, ': !WARNING! - ', AMessage);
end;

procedure my_ErrorProc(AFrom:String; AErrorNo:Longint; AMessage:String);
begin
 writeln('JSS Error #', AErrorNo, ' (from ', AFrom, '): ', AMessage); 

 { NOTICE! If some part of JSS calls jssError(), it means that it wants 
  to totally stop the program execution. So we MUST call halt() here! 
  (halt() will then shutdown JSS if ExitProc has been set right) 

  If we do not halt() the program, it may(will) have strange consequences!

  [However, in multitasking operating systems, you only have to shut down
  the thread of JSS... If you know how to do it right. ]

  REMEMBER! You can naturally do some shutdown of your program here,
  but it is also possible that you do it in the exit proc.
  (It is, however, sometimes advantageous to do some cleanup stuff here...)
 }
 halt(1);
end;


procedure my_MsgProc(AFrom, AWhat:String);
begin
 writeln('JSS Msg: ', AFrom, ': ', AWhat);
end;


procedure my_SMsgProc(AFrom, AWhat:String);
begin
 write('JSS SMsg: ', AFrom, ': ', AWhat);
end;


procedure my_PMsgProc(AMessage:String);
begin
 writeln(AMessage);
end;


begin
 {** The trick is done here **}
 jssWarning:= @my_WarningProc;
 jssError:= @my_ErrorProc;

 jssMsg:= @my_MsgProc;
 jssMsgS:= @my_SMsgProc;
 jssMsgP:= @my_PMsgProc;

 {
  REMEMBER that your own message procedures's calling syntax MUST 
  be same as shown here! Otherwise it will not work!
 }
end.
