{
 JTris - A simple textmode Tetris clone
 (c) Copyright 2000 Tecnic Software productions (TNSP)
 Programmed and designed by Matti "ccr" Hamalainen

 NOTICE! THIS EXAMPLE PROGRAM IS LICENSED UNDER
 "JSS EXAMPLE PROGRAM LICENSE" WHICH CAN BE FOUND FROM
 README FILE UNDER THIS (EXAMPLE PROGRAMS) DIRECTORY.

 DESCRIPTION:
 This program is a simple textmode Tetris clone demonstrating
 the features and usage of J Sound System (JSS) in games.

 I just wanted to make neater example programs than MIDAS guys ;)
 - ccr/TNSP -

}
program JTris;

 uses
     BaseAPI,
     JSS,
     JSSMod,
     JSSPlr;

 var
    vmSaveExitProc:Pointer;
    vmPlayer:PJSSModulePlayer;
    vmDevice:PJSSSoundDevice;
    vmModule:PJSSModule;


procedure vmExitProc;
begin
 {** Stop the music, shutdown JSS **}
 if (vmPlayer <> NIL) then

 if (vmDevice <> NIL) then

 if (vmModule <> NIL) then

 {** Now, exit this damn proc ;) **}
 ExitProc:= vmSaveExitProc;
end;



procedure vmPlayGame;

 { Update the block-area with the Tetris styled gravity law }

 { Check for full rows (aka Wins) }
 vmCollapsedRowsInRound:= 0;
 for ARow:= 1 to vmNRows do
 begin
  {** Check the row **}
  AColumns:= 1;
  AFull:= TRUE;
  while (AColumn <= vmNColumns) and
        (AFull) do
        begin
         if (vmBlocks[ARow, AColumn] = 0)
            then AFull:= FALSE
            else inc(AColumn);
        end;

  {** Collapse the row **}
  if (AFull) then
     begin
      inc(vmCollapsedRowsInRound);
      vmAddToRemovedRows(ARow);
     end;
 end;

 { Now collapse the rows and compute the scores.
   (Separating the check for full rows and collapsing them
   makes easier to add some visual tricks if this game is
   ever extended to use graphics and cool effects :-)
 }
 
 vmCurrScore:= vmCurrScore + ((1 shl vmCollapsedRowsInRound) * vmBaseRowScore)

begin
 {** GAME ON! :) **}
 { Initialize the playfield }

 { Start in-game music }
 vmPlayer^.mpPlayOrder();

end;



begin
 {** Initialize some basic thingies **}
 vmDevice:= NIL;
 vmPlayer:= NIL;
 vmModule:= NIL;
 vmSaveExitProc:= ExitProc;
 ExitProc:= @vmExitProc;

 writeln;
 writeln(vmMessage);
 writeln('* Loading data:');
 writeln('  High-scores');
 { TO-DO: Add the high-score saving and support .. }
 writeln('  Music (', SET_ModuleName, ')');
 judasLoadS3M(SET_ModuleName, vmModule);


 {** OK. The main game program **}
 vmPlayer^.mpSetOptions();  { Set looping on etc }
 vmPlayer^.mpPlayOrder();   { Start playing the menu music }
 vmExitGame:= FALSE;
 repeat
  
 until (vmExitGame);

 {** Everything concerning shutdown will be done in exitproc **}
end.

