{
  J Sound System - Original JSS setup
  (C) Copyright Tecnic Software productions (TNSP)
  Programmed and designed by Matti "ccr" Hamalainen
  PLEASE READ FILE "README" FOR CONTACTING INFORMATION!

  LICENSE:
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation (should
  be found in file COPYING in main/root directory of J Sound
  System distribution package); either version 2.1 of the
  License, or any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.
                
  You should have received a copy of the GNU Lesser General Public
  License (in file COPYING) along with this library; if not,
  write to the Free Software Foundation, Inc., 59 Temple Place,
  Suite 330, Boston, MA  02111-1307  USA.

  DESCRIPTION:
  This was/is the first setup I wrote for JSS.

  It's a bit dull, but practical.
}
{$I ..\src\jssdef.pas}
program JSSSetup;

 uses BaseAPI, JSS;

{$I ..\src\jsscfg.pas}

{$I setup_i1.pas}

 const
      {** Yleisi vakioita **}
      SETUPMessage  = 'J Sound System SETUP v'+ Version;

      {** Menusystem definations **}
      MHelpColor    = (ioCLB_Gray + ioCL_Black);
      MColor        = $08;
      MTitleColor   = $5e;

      MTextColor    = (ioCLB_Black + ioCL_Gray);
      MBarColor     = (ioCLB_Cyan + ioCL_White);
      MDisTextColor = (ioCLB_Black + ioCL_Red);
      MDisBarColor  = (ioCLB_Cyan + $0c);

      ScrColor1     = (ioCLB_Brown + ioCL_Black);
      ScrColor2     = (ioCLB_Black + ioCL_Gray);
      ScrChar       = '';

      CToggle       = '~';
      LToggle       = '@';

{$I setup_i2.pas}

 var
    {** General variables **}
    setupConfig:TJSSConfigFile;
    setupSaveExitProc:Pointer;

    {** Windowing system variables **}
    win_x, win_y,
    win_x0, win_y0,
    win_x1, win_y1:Longint;
    win_color:Word;


{****************************************************************************}
{*                                                                          *}
{* Sekalaisia yleisi funktioita                                            *}
{*                                                                          *}
{****************************************************************************}
function setupCStrLen(AStr:String):Longint; Assembler;
asm
        { Get address of Str to DS:SI }
        lea edi, [AStr]; { Get string address }
        xor eax, eax;    { EAX-counter = 0 }
        xor ecx, ecx;
        mov cl, [edi];   { Get string length }
        or  cl, cl;
        jz  @out;
        inc edi;

@lp0:   mov bl, [edi];
        inc edi;
        cmp bl, CToggle;
        je  @lp1;

        inc eax;
@lp1:   dec ecx;
        jnz @lp0;

@out:
end;


procedure setupEBox(x0, y0, x1, y1:Longint; ATitle:String; BColor, BTitle:Byte);
 var ATemp:Longint;
begin
 {** Draw a shadowed box with title **}
 ioRectFill(x0, y0+1, x1, y1, #32, BColor);

 ioRectFill(x0, y0, x1, y0, #32, BTitle);
 ATemp:= ((x1 - x0) shr 1) - ((length(ATitle) + 4) shr 1);
 ioWriteCXY(x0 + ATemp, y0, '- '+ ATitle +' -');

 ioFlush;
end;


procedure NextLine;
begin
 win_x:= 0;
 inc(win_y);
end;


procedure WriteWin(AStr:String);
 var
    AIndex:Longint;
    AAttrib:Byte;
begin
 {** Print line **}
 AAttrib:= 1;
 AIndex := 1;

 repeat
   case AStr[AIndex] of
    CToggle: if (AAttrib <> 2)
                then AAttrib:= 2
                else AAttrib:= 1;

    LToggle: NextLine;

    else begin
          ioPutR((win_x0 + 1 + win_x), (win_y0 + 1 + win_y), AStr[AIndex], WRec(win_color)[AAttrib]);
          inc(win_x);
          if ((win_x0 + 1 + win_x) >= win_x1)
             then NextLine;
         end;
   end;
   inc(AIndex);
 until (AIndex > length(AStr)) or
       ((win_y0 + 1 + win_y) > win_y1);
end;


procedure setupWindow(x0, y0, x1, y1:Longint; ATitle:String; AColor:Byte; ATextColor:Word);
begin
 win_x:= 0; win_y:= 0;
 win_color:= ATextColor;
 win_x0:= x0; win_y0:= y0;
 win_x1:= x1; win_y1:= y1;

 setupEBox(x0, y0, x1, y1, ATitle, AColor, AColor);
end;


procedure setupStartAnimation;
begin
 ioRectFill(0, 0, (ioScrWidth-1), 0, #32, MHelpColor);
 ioRectFill(0, 1, (ioScrWidth-1), (ioScrHeight-2), ScrChar, ScrColor1);
 ioWriteCXY(1, 0, SETUPMessage + ioCopyright);

 ioFlush;
end;


{****************************************************************************}
{*                                                                          *}
{* Menujrjestelmn funktiot                                                *}
{*                                                                          *}
{****************************************************************************}
function setupExecuteMenu(XCoord, YCoord:Longint; AMenu:TMenu; AInitItem:Longint):Longint;
 var
    ATemp, AIndex,
    MWidth,
    MHeight:Longint;

    AOldItem,
    ACurrItem:Longint;
    AKey:Word;
    AEndMenu:Boolean;

procedure setupDrawMenu;
 var
    AItemStr:String;
    ATemp, AItem:Longint;
begin
 {** Draw the menu items **}
 for AItem:= 1 to AMenu.Items do
 begin
      {** Delete the old menubar **}
      if (AItem = AOldItem) then
      for ATemp:= 0 to (MWidth - 1) do
          ioPutAttr(XCoord + ATemp, (YCoord + AItem - 1), MTextColor);

      {** Now draw the menuitem **}
      AItemStr:= AMenu.ItemList[AItem];
      if (AItemStr[1] = '~') then
      begin
       for ATemp:= 0 to (MWidth - 1) do
           ioPutChar(XCoord + ATemp, (YCoord + AItem - 1), '');
      end else
      begin
       {** Draw menu item **}
       if (AMenu.Center)
          then ATemp:= XCoord + (MWidth shr 1) - (length(AItemStr) shr 1)
          else ATemp:= XCoord;

       {** Draw a menuitem **}
       if (AMenu.ItemEnabled[AItem])
          then ioWriteXY(ATemp, YCoord + AItem - 1, AItemStr, MTextColor)
          else ioWriteXY(ATemp, YCoord + AItem - 1, AItemStr, MDisTextColor);

       {** Draw menu selection bar **}
       if (AItem = ACurrItem) then
       if (AMenu.ItemEnabled[AItem]) then
       begin
        for ATemp:= 0 to (MWidth - 1) do
            ioPutAttr(XCoord + ATemp, (YCoord + AItem - 1), MBarColor);
       end else
       begin
        for ATemp:= 0 to (MWidth - 1) do
            ioPutAttr(XCoord + ATemp, (YCoord + AItem - 1), MDisBarColor);
       end;
      end;
 end;

 AOldItem:= ACurrItem;

 {** Piirr helppi **}
 ioRectFill(0, (ioScrHeight-1), (ioScrWidth-1), (ioScrHeight-1), #32, MHelpColor);
 ioWriteCXY(1, (ioScrHeight-1), AMenu.ItemHelp[ACurrItem]);

 ioFlush;
end;


begin
 {** Initialize menu **}
 MHeight:= AMenu.Items;
 MWidth:= 0;
 for AIndex:= 1 to AMenu.Items do
 begin
  ATemp:= length(AMenu.ItemList[AIndex]);
  if (ATemp > MWidth)
     then MWidth:= ATemp;
 end;
 MWidth:= MWidth + 8;

 ATemp:= length(AMenu.Title);
 if ((ATemp + 8) > MWidth)
    then MWidth:= (ATemp + 8);

 {** Draw the menubox **}
 setupEBox(XCoord - 1, YCoord - 1, XCoord + MWidth, YCoord + MHeight,
           AMenu.Title, MColor, MTitleColor);

 {** Okay. Execute the menu **}
 AOldItem:= AInitItem;
 ACurrItem:= AInitItem;
 AEndMenu:= false;
 setupDrawMenu;

 repeat
  {** Wait for a key **}
  AKey:= ioGetKey;

  case AKey of
   kbUp   : begin
             repeat
              dec(ACurrItem);
              if (ACurrItem < 1) then
                 ACurrItem:= AMenu.Items;
             until (AMenu.ItemList[ACurrItem] <> '~');
             setupDrawMenu;
            end;

   kbDown : begin
             repeat
              inc(ACurrItem);
              if (ACurrItem > AMenu.Items) then
                 ACurrItem:= 1;
             until (AMenu.ItemList[ACurrItem] <> '~');
             setupDrawMenu;
            end;

   kbHome: begin
            ACurrItem:= 1;
            while (AMenu.ItemList[ACurrItem] = '~') do
            begin
             inc(ACurrItem);
             if (ACurrItem > AMenu.Items) then
                ACurrItem:= 1;
            end;
            setupDrawMenu;
           end;

   kbEnd: begin
            ACurrItem:= AMenu.Items;
            while (AMenu.ItemList[ACurrItem] = '~') do
            begin
             dec(ACurrItem);
             if (ACurrItem < 1) then
                ACurrItem:= AMenu.Items;
            end;
            setupDrawMenu;
           end;

   kbEnter: if (AMenu.ItemList[ACurrItem][1] <> '*') and
               (AMenu.ItemEnabled[ACurrItem])
               then AEndMenu:= true;

   kbEsc  : begin
             ACurrItem:= -1;
             AEndMenu:= true;
            end;

   else ioWriteCXY(ioScrWidth-8, 0, ioHexW(AKey));
  end;
 until (AEndMenu);

 {** Shutdown menu **}
 ioRectFill(XCoord - 1, YCoord - 1, XCoord + MWidth + 1, YCoord + MHeight + 1,
            ScrChar, ScrColor1);

 ioFlush;

 setupExecuteMenu:= ACurrItem;
end;


{****************************************************************************}
{*                                                                          *}
{* Device settings menu routines                                            *}
{*                                                                          *}
{****************************************************************************}
function setupGetDMA8:Boolean;
 var
    AMenu:TMenu;
    AValue:Word;
    AOption:Longint;
begin
 {** Initialize menu **}
 with AMenu do
 begin
  Title  := 'Select LOW 8-bit DMA';
  Items  := SDMA8Items;
  Center := TRUE;

  for AOption:= 1 to Items do
      begin
       AValue:= SDMA8List[AOption];
       ItemList[AOption]:= 'DMA '+ ioStrW(AValue);
       ItemHelp[AOption]:= 'Set LOW 8-bit DMA channel to '+ ioStrW(AValue);
       ItemEnabled[AOption]:= TRUE;
      end;
 end;

 {** Execute the menu **}
 setupGetDMA8:= true;
 AOption:= setupExecuteMenu(25, 4, AMenu, 1);
 if (AOption <> -1)
    then setupConfig.SlDMA:= SDMA8List[AOption]
    else setupGetDMA8:= false;
end;


function setupGetDMA16:Boolean;
 var
    AMenu:TMenu;
    AValue:Word;
    AOption:Longint;
begin
 {** Initialize menu **}
 with AMenu do
 begin
  Title  := 'Select HIGH 16-bit DMA';
  Items  := SDMA16Items;
  Center := TRUE;

  for AOption:= 1 to Items do
      begin
       AValue:= SDMA16List[AOption];
       ItemList[AOption]:= 'DMA '+ ioStrW(AValue);
       ItemHelp[AOption]:= 'Set HIGH 16-bit DMA channel to '+ ioStrW(AValue);
       ItemEnabled[AOption]:= TRUE;
      end;
 end;

 {** Execute the menu **}
 setupGetDMA16:= true;
 AOption:= setupExecuteMenu(25, 4, AMenu, 1);
 if (AOption <> -1)
    then setupConfig.ShDMA:= SDMA16List[AOption]
    else setupGetDMA16:= false;
end;


function setupGetBase:Boolean;
 var
    AMenu:TMenu;
    AValue:Word;
    AOption:Longint;
begin
 {** Initialize menu **}
 with AMenu do
 begin
  Title  := 'Select base I/O port';
  Items  := SBaseItems;
  Center := TRUE;

  for AOption:= 1 to Items do
      begin
       AValue:= SBaseList[AOption];
       ItemList[AOption]:= ioHexW(AValue) +'H';
       ItemHelp[AOption]:= 'Set base I/O port to '+ ioHexW(AValue) +'H';
       ItemEnabled[AOption]:= TRUE;
      end;
 end;

 {** Execute the menu **}
 setupGetBase:= true;
 AOption:= setupExecuteMenu(25, 4, AMenu, 1);
 if (AOption <> -1)
    then setupConfig.SBase:= SBaseList[AOption]
    else setupGetBase:= false;
end;


function setupGetIRQ:Boolean;
 var
    AMenu:TMenu;
    AValue:Word;
    AOption:Longint;
begin
 {** Initialize menu **}
 with AMenu do
 begin
  Title  := 'Select IRQ-line';
  Items  := SIRQItems;
  Center := TRUE;

  for AOption:= 1 to Items do
      begin
       AValue:= SIRQList[AOption];
       ItemList[AOption]:= 'IRQ '+ ioStrW(AValue);
       ItemHelp[AOption]:= 'Set IRQ-line to '+ ioStrW(AValue);
       ItemEnabled[AOption]:= TRUE;
      end;
 end;

 {** Execute the menu **}
 setupGetIRQ:= true;
 AOption:= setupExecuteMenu(25, 4, AMenu, 1);
 if (AOption <> -1)
    then setupConfig.SIRQ:= SIRQList[AOption]
    else setupGetIRQ:= false;
end;


function setupGetMixingSpeed:Boolean;
 var
    AMenu:TMenu;
    AValue:Word;
    AOption:Longint;
begin
 {** Initialize menu **}
 with AMenu do
 begin
  Title  := 'Select mixing frequency';
  Items  := SMixSpeedItems;
  Center := TRUE;

  for AOption:= 1 to Items do
      begin
       AValue:= SMixSpeedList[AOption];
       ItemList[AOption]:= ioStrW(AValue) +' Hz';
       ItemHelp[AOption]:= 'Set mixing frequency to '+ ioStrL(AValue)
       +' Hz ('+ ioStrL(AValue div 1000) +' kHz)';
       ItemEnabled[AOption]:= TRUE;
      end;
 end;

 {** Execute the menu **}
 setupGetMixingSpeed:= true;
 AOption:= setupExecuteMenu(25, 4, AMenu, 1);
 if (AOption <> -1)
    then setupConfig.SOutFreq:= SMixSpeedList[AOption]
    else setupGetMixingSpeed:= false;
end;


function setupGetOutputMode:Boolean;
begin
 setupGetOutputMode:= true;
 case setupExecuteMenu(25, 4, OutputModeMenu, 1) of
  1: setupConfig.SOutMode16bit:= TRUE;
  2: setupConfig.SOutMode16bit:= FALSE;
  else setupGetOutputMode:= false;
 end;
end;


{****************************************************************************}
{*                                                                          *}
{* Sound Device Information Routines                                        *}
{*                                                                          *}
{****************************************************************************}
function setupGetDeviceName:String;
 var AStr:String;
begin
 case setupConfig.SDevice of
  sdSoundBlaster      : AStr:= 'Sound Blaster';
  sdGravisUltrasound  : AStr:= 'Gravis Ultrasound';
  sdProAudioSpectrum  : AStr:= 'Pro Audio Spectrum';
  sdWindowsSoundSystem: AStr:= 'Windows Sound System';
  sdPCSpeaker         : AStr:= 'PC Speaker';
  sdDiskWriter        : AStr:= 'Disk Writer';
  sdOSS		      : AStr:= 'OSS Linux';
  sdNoSound           : AStr:= 'No Sound';
  else                  AStr:= 'INTERNAL ERROR!';
 end;

 setupGetDeviceName:= AStr;
end;


procedure setupPrintSettings;
 var AQuality:Longint; ATempStr:String;
begin
 {** Show the current sound settings **}
 setupWindow(3, ioScrHeight-11, ioScrWidth-4, ioScrHeight-2, 'Current sound settings', $1e, $1f17);
 WriteWin('Sound source/device.: ~'+ setupGetDeviceName +'@');

 if (setupConfig.SDevice <> sdNoSound) then
 begin
   {** Show device information **}
   if NOT (setupConfig.SDevice in [sdDiskWriter, sdPCSpeaker, sdOSS]) then
   begin
   WriteWin('Base I/O port.......: ~'+ ioHexW(setupConfig.SBase) +'~H@');
   WriteWin('IRQ-line............: ~'+ ioStrW(setupConfig.SIRQ) +'@');
   WriteWin('DMA channels........: Low: ~'+ ioStrW(setupConfig.SlDMA) +'~, High: ~'+ ioStrW(setupConfig.ShDMA) +'~@');
   end;

   {** Determine output mode settings **}
   if (setupConfig.SDevice <> sdPCSpeaker) then
   begin
    if (setupConfig.SOutMode16bit)
       then ATempStr:= '16 bits~'
       else ATempStr:= '8 bits~';

    if (setupConfig.SOutModeStereo)
       then ATempStr:= ATempStr + ', ~stereo~'
       else ATempStr:= ATempStr + ', ~mono~';

    WriteWin('Output mode.........: ~'+ ATempStr +'@');
   end;

   if (setupConfig.SDevice <> sdGravisUltrasound) then
   begin
    {** Determine mixing mode settings **}
    ATempStr:= '';
    if (setupConfig.SMixInterpolate) then
       ATempStr:= ATempStr +'interpolated';

    {** Show the information **}
    WriteWin('Mixing frequency....: ~'+ ioStrW(setupConfig.SOutFreq) +' ~Hz@');
    WriteWin('Mixing flags........: ~'+ ATempStr +'@');

    {** Comment quality of sound output **}
    AQuality:= 0;
    if (setupConfig.SOutFreq >= 11025) then inc(AQuality);
    if (setupConfig.SOutFreq >= 22050) then inc(AQuality);
    if (setupConfig.SOutFreq >= 33075) then inc(AQuality);
    if (setupConfig.SOutFreq >= 44100) then inc(AQuality);

    if (setupConfig.SOutMode16bit) then
       AQuality:= (AQuality * 2);

    if (setupConfig.SMixInterpolate)
       then AQuality:= (AQuality * 2);

    WriteWin('Output quality......: ~'+ ioStrL(AQuality));
   end;

 end;
 ioFlush;
end;


{****************************************************************************}
{*                                                                          *}
{* Setup Main program                                                       *}
{*                                                                          *}
{****************************************************************************}
procedure setupSoundDevice;
 var
    AOption, ADeviceOption:Longint;
    AEndDeviceMenu:Boolean;

procedure setupSetDevItem(AItem:Longint; ASetting:Boolean);
begin
 with DeviceSetupMenu do
 if (AItem > 0) and
    (AItem <= Items) then
    ItemEnabled[AItem]:= ASetting;
end;

procedure setupUpdateDeviceMenu;
 var i:Longint;
begin
 case setupConfig.SDevice of
  sdNoSound: for i:= 3 to 10 do setupSetDevItem(i, false);

  sdPCSpeaker: begin
                for i:= 3 to 5 do setupSetDevItem(i, false);
                for i:= 6 to 8 do setupSetDevItem(i, true);
                setupSetDevItem(9, false);
                setupSetDevItem(10, false);
                setupConfig.SOutModeStereo:= TRUE;
                setupConfig.SOutMode16bit:= FALSE;
               end;

  sdSoundBlaster,
  sdProAudioSpectrum,
  sdWindowsSoundSystem,
  sdGravisUltrasound:
             for i:= 3 to 10 do setupSetDevItem(i, true);

  sdDiskWriter,
  sdOSS:
             begin
              for i:= 3 to 5 do setupSetDevItem(i, false);
              for i:= 6 to 10 do setupSetDevItem(i, true);
             end;
 end;
end;


begin
 ADeviceOption:= 1;
 AEndDeviceMenu:= false;
 repeat
  setupUpdateDeviceMenu;
  setupPrintSettings;

  {** Sound Main Setup Menu **}
  ADeviceOption:= setupExecuteMenu(2, 2, DeviceSetupMenu, ADeviceOption);
  case ADeviceOption of
   1: begin
       AOption:= setupExecuteMenu(27, 2, DeviceMenu, 1);
       if (AOption <> -1) then
          setupConfig.SDevice:= DeviceMenuList[AOption];
      end;

   3: setupGetBase;
   4: setupGetIRQ;
   5: if (setupGetDMA8) then setupGetDMA16;
   6: setupGetMixingSpeed;
   7: setupConfig.SMixInterpolate:= NOT setupConfig.SMixInterpolate;
   8: setupConfig.SOutModeStereo:= NOT setupConfig.SOutModeStereo;
   9: setupGetOutputMode;

   -1: AEndDeviceMenu:= true;
  end;
 until (AEndDeviceMenu);
end;


{****************************************************************************}
{*                                                                          *}
{* Setup Main program                                                       *}
{*                                                                          *}
{****************************************************************************}
 var
    setupConfFilename:String;
    setupExitPrg:Boolean;
    setupOption:Longint;

function setupLoadConfig:Boolean;
 var AConfigF:File;
begin
 {** Open the file **}
 setupLoadConfig:= false;
 Assign(AConfigF, setupConfFilename);
 Reset(AConfigF, 1);
 if (IOResult <> 0) then exit;

 {** Read the configuration **}
 blockread(AConfigF, setupConfig, sizeof(TJSSConfigFile));
 if (IOResult <> 0) then exit;
 close(AConfigF);

 setupLoadConfig:= true;
end;


function setupSaveConfig:Boolean;
 var AConfigF:File;
begin
 {** Create the file **}
 setupSaveConfig:= false;
 Assign(AConfigF, setupConfFilename);
 Rewrite(AConfigF, 1);
 if (IOResult <> 0) then exit;

 {** Read the configuration **}
 blockwrite(AConfigF, setupConfig, sizeof(TJSSConfigFile));
 if (IOResult <> 0) then exit;
 close(AConfigF);

 setupSaveConfig:= true;
end;


procedure setupResetConfig;
begin
 with setupConfig do
 begin
  {** Initialize header **}
  AHeader:= jssCfgHeader;
  AVersion:= jssCfgVersion;

  {** Initialize information **}
  SDevice:= sdNoSound;

  SBase:= -1;
  SIRQ:= -1;
  SlDMA:= -1;
  ShDMA:= -1;

  SOutFreq:= 0;
  SOutMode16bit:= FALSE;
  SOutModeStereo:= TRUE;
  SMixInterpolate:= FALSE;
 end;
end;


procedure setupExitProc;
begin
 {** Exit the program with a neat message ;) **}
 ioClrScr(ioCLB_Black + ioCL_Gray);
 ioWriteXY(0, 0, SETUPMessage + ioCopyright, ioCLB_Black+ioCL_White);
 ioGotoXY(0, 1);

 ioFlush;

 if (ioClose <> ioerrOK) then
    writeln('Error closing libBaseAPI!');

 ExitProc:= setupSaveExitProc;
end;


begin
 {**** Yleinen initialisaatio ****}
 setupSaveExitProc:= ExitProc;
 ExitProc:= @setupExitProc;
 writeln;
 writeln(SETUPMessage);
 writeln(ioCopyright);

 if (ioInit <> ioerrOK) then
    begin
     writeln('libBaseAPI initialization failed!');
     halt;
    end;

 setupConfFilename:= SETUPFilename;

 {** Load configuration or defaults **}
 if (setupLoadConfig = false)
    then setupResetConfig;

 {**** SETUP Main Program loop ****}
 setupOption:= 1;
 setupExitPrg:= false;
 setupStartAnimation;
 repeat
  {** Update the info screen **}
  setupPrintSettings;

  {** Execute the main menu **}
  setupOption:= setupExecuteMenu(4, 3, MainMenu, setupOption);
  case setupOption of
    1: setupSoundDevice;
    2: setupResetConfig;

    4: begin
        {** Save the configuration file **}
        setupWindow(10, 2,  70, 6, 'Saving settings', $3f, $3e3f);
        if (setupSaveConfig) then
           WriteWin('Settings saved to file@') else
           WriteWin('Error saving settings to file@');

        WriteWin('"~'+ setupConfFilename +'~"@');
        WriteWin('~Hit any key to quit.');
        ioFlush;
        ioGetKey;
        setupExitPrg:= true;
       end;

   -1, 6: setupExitPrg:= true;
  end;
 until (setupExitPrg);

end.
