{
  J Sound System - Mixing routines
  (C) Copyright Tecnic Software productions (TNSP)
  Programmed and designed by Matti "ccr" Hamalainen
  PLEASE READ FILE "README" FOR CONTACTING INFORMATION!

  LICENSE:
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation (should
  be found in file COPYING in main/root directory of J Sound
  System distribution package); either version 2.1 of the
  License, or any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.
                
  You should have received a copy of the GNU Lesser General Public
  License (in file COPYING) along with this library; if not,
  write to the Free Software Foundation, Inc., 59 Temple Place,
  Suite 330, Boston, MA  02111-1307  USA.

  DESCRIPTION:
  Used by JSS to produce 8/16-bit sound output, either mono or stereo.
}

 const qH:Longint = 0; qP:Longint = 0;

procedure TJSSMixingDevice.vmClearAddBuffer;
 var Q:Pointer;
begin
 Q:= @Self;
 asm
          {** Clear the addition-buffer **}
          mov esi, [Q];

          { Initialize the EAX with addbuf initval }
          xor eax, eax;

          { The init other values }
          mov edi, TJSSMixingDevice[esi].SAddBuffer;   { EDI = Addition buffer }

          mov ecx, TJSSMixingDevice[esi].SUMixBufSize; { ECX = Mixed data length in UNITS }
          mov ebx, ecx;                { EBX = ECX }
          shr ecx, 2;                  { Divide ECX by 4 }

          or  ecx, ecx;                { Check for zero }
          jz  @lnofl;


          {** Clear the addition-buffer **}
@lclear1: mov [edi],    eax;
          mov [edi+4],  eax;
          mov [edi+8],  eax;
          mov [edi+12], eax;

          add edi, 16;

          dec ecx;
          jnz @lclear1;


          {** Clear the rest of the buffer **}
@lnofl:   mov ecx, ebx;                { Mask out the rest bits }
          and ecx, 3;                  { of the buffer size count }

          or  ecx, ecx;                { Check for zero }
          jz  @lout;                   { Exit if it was zero }

@lclear2: mov [edi], eax;

          add edi, 4;

          dec ecx;
          jnz @lclear2;


          {** Restore registers **}
@lout:
 end;
end;


{$ifdef SUP_MIXING_PREC_8BIT}
{$ifdef SUP_MIXING_PREC_MONO}
procedure TJSSMixingDevice.vmMix8bitMono(AMixDestBuffer:Pointer);

{$I jmixmono.inc}

{$I jmixcbl.inc}

 {** Do the post-processing **}
 if (SOutModeSigned)
    then vmDoPostProcessing8Signed(AMixDestBuffer, SUMixBufSize)
    else vmDoPostProcessing8Unsigned(AMixDestBuffer, SUMixBufSize);
end;
{$endif}

{$ifdef SUP_MIXING_PREC_STEREO}
procedure TJSSMixingDevice.vmMix8bitStereo(AMixDestBuffer:Pointer);

{$I jmixstro.inc}

{$I jmixcbl.inc}

 {** Do the post-processing **}
 if (SOutModeSigned)
    then vmDoPostProcessing8Signed(AMixDestBuffer, SUMixBufSize*2)
    else vmDoPostProcessing8Unsigned(AMixDestBuffer, SUMixBufSize*2);
end;
{$endif}
{$endif}


{$ifdef SUP_MIXING_PREC_16BIT}
{$ifdef SUP_MIXING_PREC_MONO}
procedure TJSSMixingDevice.vmMix16bitMono(AMixDestBuffer:Pointer);

{$I jmixmono.inc}

{$I jmixcbl.inc}

 {** Do the post-processing **}
 if (SOutModeSigned)
    then vmDoPostProcessing16Signed(AMixDestBuffer, SUMixBufSize)
    else vmDoPostProcessing16Unsigned(AMixDestBuffer, SUMixBufSize);
end;
{$endif}


{$ifdef SUP_MIXING_PREC_STEREO}
procedure TJSSMixingDevice.vmMix16bitStereo(AMixDestBuffer:Pointer);

{$I jmixstro.inc}

{$I jmixcbl.inc}

 {** Do the post-processing **}
 if (SOutModeSigned)
    then vmDoPostProcessing16Signed(AMixDestBuffer, SUMixBufSize*2)
    else vmDoPostProcessing16Unsigned(AMixDestBuffer, SUMixBufSize*2);
end;
{$endif}
{$endif}


