{
  J Sound System - Post-processing Routines
  (C) Copyright Tecnic Software productions (TNSP)
  Programmed and designed by Matti "cCr" Hamalainen
  PLEASE READ FILE "README" FOR CONTACTING INFORMATION!

  LICENSE:
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation (should
  be found in file COPYING in main/root directory of J Sound
  System distribution package); either version 2.1 of the
  License, or any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.
                
  You should have received a copy of the GNU Lesser General Public
  License (in file COPYING) along with this library; if not,
  write to the Free Software Foundation, Inc., 59 Temple Place,
  Suite 330, Boston, MA  02111-1307  USA.
}

 const
      jmix16LimitPos =  32767;
      jmix16LimitNeg = -32767;


{$ifdef SUP_MIXING_PREC_16BIT}
procedure TJSSMixingDevice.vmDoPostProcessing16Unsigned(AMixDestBuffer:Pointer; AMixDestLength:Cardinal);
 var Q:Pointer;
begin
 Q:= @Self;

 asm
          {** Do post-processing cycle **}
          mov esi, [Q];

          mov esi, TJSSMixingDevice[esi].SAddBuffer;   { ESI = Addition buffer }

          mov ecx, [AMixDestLength];

          mov edi, [AMixDestBuffer];   { EDI = Destination mixing buffer }

          {** Set the limits **}
          mov edx, jmix16LimitPos;
          mov ebx, jmix16LimitNeg;

          push ebp;

          mov ebp, 32768;

          {** Do the post processing **}
@lpost1:  
          mov eax, [esi];  

          cmp eax, edx;
          jle @lpOK1;
          mov eax, edx;

@lpOK1:   cmp eax, ebx;
          jge @lpOK2;
          mov eax, ebx;

@lpOK2:
          add eax, ebp;
          mov [edi], ax;

          add esi, 4;
          add edi, 2;
          
          dec ecx;
          jnz @lpost1;

          pop ebp;

          {** Restore registers **}
@lok:
 end;
end;


procedure TJSSMixingDevice.vmDoPostProcessing16Signed(AMixDestBuffer:Pointer; AMixDestLength:Cardinal);
 var Q:Pointer;
begin
 Q:= @Self;

 asm
          {** Do post-processing cycle **}
          mov esi, [Q];

          mov esi, TJSSMixingDevice[esi].SAddBuffer;   { ESI = Addition buffer }

          mov ecx, [AMixDestLength];

          mov edi, [AMixDestBuffer];   { EDI = Destination mixing buffer }

          {** Set the limits **}
          mov edx, jmix16LimitPos;
          mov ebx, jmix16LimitNeg;

          {** Do the post processing **}
@lpost1:  
          mov eax, [esi];

          cmp eax, edx;
          jle @lpOK1;
          mov eax, edx;

@lpOK1:   cmp eax, ebx;
          jge @lpOK2;
          mov eax, ebx;

@lpOK2:
          mov [edi], ax;

          add esi, 4;
          add edi, 2;
          
          dec ecx;
          jnz @lpost1;

          {** Restore registers **}
@lok:
 end;
end;
{$endif}


{$ifdef SUP_MIXING_PREC_8BIT}
procedure TJSSMixingDevice.vmDoPostProcessing8Unsigned(AMixDestBuffer:Pointer; AMixDestLength:Cardinal);
 var Q:Pointer;
begin
 Q:= @Self;

 asm
          {** Do post-processing cycle **}
          mov esi, [Q];

          mov esi, TJSSMixingDevice[esi].SAddBuffer;   { ESI = Addition buffer }

          mov ecx, [AMixDestLength];

          mov edi, [AMixDestBuffer];   { EDI = Destination mixing buffer }

          {** Set the limits **}
          mov edx, jmix16LimitPos;
          mov ebx, jmix16LimitNeg;

          push ebp;

          mov ebp, 32768;

          {** Do the post processing **}
@lpost1:  
          mov eax, [esi];  

          cmp eax, edx;
          jle @lpOK1;
          mov eax, edx;

@lpOK1:   cmp eax, ebx;
          jge @lpOK2;
          mov eax, ebx;

@lpOK2:
          add eax, ebp;
          shr eax, 8;
          mov [edi], al;

          add esi, 4;
          inc edi;
          
          dec ecx;
          jnz @lpost1;

          pop ebp;

          {** Restore registers **}
@lok:
 end;
end;


procedure TJSSMixingDevice.vmDoPostProcessing8Signed(AMixDestBuffer:Pointer; AMixDestLength:Cardinal);
 var Q:Pointer;
begin
 Q:= @Self;

 asm
          {** Do post-processing cycle **}
          mov esi, [Q];

          mov esi, TJSSMixingDevice[esi].SAddBuffer;   { ESI = Addition buffer }

          mov ecx, [AMixDestLength];

          mov edi, [AMixDestBuffer];   { EDI = Destination mixing buffer }

          {** Set the limits **}
          mov edx, jmix16LimitPos;
          mov ebx, jmix16LimitNeg;

          {** Do the post processing **}
@lpost1:  
          mov eax, [esi];

          cmp eax, edx;
          jle @lpOK1;
          mov eax, edx;

@lpOK1:   cmp eax, ebx;
          jge @lpOK2;
          mov eax, ebx;

@lpOK2:
          sar eax, 8;
          mov [edi], al;

          add esi, 4;
          inc edi;
          
          dec ecx;
          jnz @lpost1;

          {** Restore registers **}
@lok:
 end;
end;

{$endif}
