{
  J Sound System - Amiga Tracker (MOD) module loader
  (C) Copyright Tecnic Software productions (TNSP)
  Programmed and designed by Matti "ccr" Hamalainen
  PLEASE READ FILE "README" FOR CONTACTING INFORMATION!

  LICENSE:
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation (should
  be found in file COPYING in main/root directory of J Sound
  System distribution package); either version 2.1 of the
  License, or any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.
                
  You should have received a copy of the GNU Lesser General Public
  License (in file COPYING) along with this library; if not,
  write to the Free Software Foundation, Inc., 59 Temple Place,
  Suite 330, Boston, MA  02111-1307  USA.

  DESCRIPTION:
  Self explanatory.

  TO-DO:
  - Get other MOD subformats for testing.
    (Help me!)
}

{$ifdef GET_IMPLEMENTATION}
 const
      {** MOD data string **}
      MOD_DataString = 'MOD loader v1.30 (updated 12/5/2001)';
{$endif}

{$ifdef GET_REGISTRATION}
 jssRegisterLoader(jmdtMOD, @jssLoadMOD, @jssDetectMOD, 'MOD', MOD_DataString);
{$endif}


{$ifdef GET_INTERFACE}
 const
      {** INTERNAL FLAGS, FORMAT SPECIFIC **}
      { MOD specific flags }
      jmdiUnknownModule  = $00000000;  { Unknown MOD type }
      jmdiSTmodule       = $00000001;  { Sound Tracker (Unknown/DOC and others) }
      jmdiPTmodule       = $00000002;  { Pro Tracker   (Cryptoburners, Amiga Freelancers, etc) }
      jmdiFTmodule       = $00000003;  { Fast Tracker  (Triton Productions) }
      jmdiNTmodule       = $00000004;  { Noise Tracker (???) }
      jmdiUSTmodule      = $00000005;  { Ultimate Sound Tracker (original Karsten Obarski product!) }
      jmdiSTTmodule      = $00000006;  { }

 type
     {** MOD subtype data record **}
     PMODTypeData = ^TMODTypeData;
     TMODTypeData = record
      AIdent:String4;     { Identificator string }
      NChannels,          { Number of channels }
      NInstr:Byte;        { Number of instruments }
      IFlags:Longint;     { Flags for player and loader }
      AFlags:Longint;     { General flags }
     end;
{$endif}


{$ifdef GET_IMPLEMENTATION}
 const
      {** MOD specific sizedefs **}
      MOD_MaxChannels    = 32;
      MOD_MaxRows        = 64;    { Number of rows in pattern }
      MOD_MaxPatterns    = 99;    { Max. number of Patterns in module }
      MOD_MaxOrders      = 128;   { Max. number of Orders in song }
      MOD_MaxInstruments = 31;
      MOD_SongNameLength = 20;

      { NOTICE!!! The number of instruments and channels
        are determined by the subtype of MOD. }

      MOD_PeriodTolerance = 1;

      {** MOD subtype defines **}
      jsetMODTypes       = 20;
      jsetMODTypeIdents:Array[1..jsetMODTypes] of TMODTypeData = (
      (AIdent:'FLT4'; NChannels:04; NInstr: 31; IFlags:jmdiSTTmodule;AFlags: 0),{ NewTracker/Startrekker formats }
      (AIdent:'M.K.'; NChannels:04; NInstr: 31; IFlags:jmdiSTmodule; AFlags: 0),{ SoundTracker formats }
      (AIdent:'M!K!'; NChannels:08; NInstr: 31; IFlags:jmdiPTmodule; AFlags: 0),{ PT 2.3, when pats > 64 }
      (AIdent:'N.T.'; NChannels:04; NInstr: 31; IFlags:jmdiNTmodule; AFlags: 0),{ NoiseTracker formats }
      (AIdent:'4CHN'; NChannels:04; NInstr: 31; IFlags:jmdiFTmodule; AFlags: jmdfFT2Replay),  { FastTracker I & II }
      (AIdent:'6CHN'; NChannels:06; NInstr: 31; IFlags:jmdiFTmodule; AFlags: jmdfFT2Replay),
      (AIdent:'8CHN'; NChannels:08; NInstr: 31; IFlags:jmdiFTmodule; AFlags: jmdfFT2Replay),
      (AIdent:'CD81'; NChannels:08; NInstr: 31; IFlags:0;            AFlags: 0),{ Atari ST Octalyser }
      (AIdent:'10CH'; NChannels:10; NInstr: 31; IFlags:jmdiFTmodule; AFlags: jmdfFT2Replay),
      (AIdent:'12CH'; NChannels:12; NInstr: 31; IFlags:jmdiFTmodule; AFlags: jmdfFT2Replay),
      (AIdent:'14CH'; NChannels:14; NInstr: 31; IFlags:jmdiFTmodule; AFlags: jmdfFT2Replay),
      (AIdent:'16CH'; NChannels:16; NInstr: 31; IFlags:jmdiFTmodule; AFlags: jmdfFT2Replay),
      (AIdent:'18CH'; NChannels:18; NInstr: 31; IFlags:jmdiFTmodule; AFlags: jmdfFT2Replay),
      (AIdent:'20CH'; NChannels:20; NInstr: 31; IFlags:jmdiFTmodule; AFlags: jmdfFT2Replay),
      (AIdent:'22CH'; NChannels:22; NInstr: 31; IFlags:jmdiFTmodule; AFlags: jmdfFT2Replay),
      (AIdent:'24CH'; NChannels:24; NInstr: 31; IFlags:jmdiFTmodule; AFlags: jmdfFT2Replay),
      (AIdent:'26CH'; NChannels:26; NInstr: 31; IFlags:jmdiFTmodule; AFlags: jmdfFT2Replay),
      (AIdent:'28CH'; NChannels:28; NInstr: 31; IFlags:jmdiFTmodule; AFlags: jmdfFT2Replay),
      (AIdent:'30CH'; NChannels:30; NInstr: 31; IFlags:jmdiFTmodule; AFlags: jmdfFT2Replay),
      (AIdent:'32CH'; NChannels:32; NInstr: 31; IFlags:jmdiFTmodule; AFlags: jmdfFT2Replay));

      {** Sub-formats with no identification tag (use heuristics) **}
      jsetMODTypes2      = 2;
      jsetMODTypeIdents2:Array[1..jsetMODTypes2] of TMODTypeData = (
      (AIdent:'ST15'; NChannels:04; NInstr: 15; IFlags:jmdiSTmodule),  { 15-inst SoundTracker }
      (AIdent:'U-ST'; NChannels:04; NInstr: 15; IFlags:jmdiUSTmodule)  { Original Ultimate SoundTracker }
      );

{$I ../plrsys/jplay-i2.pas}

 type
     {** MOD-instrument **}
     TMODInstrument = record
      Description:String22;    { Instrument name }
      Size:Word;               { Instrument Size in WORDS (16bit) }
      FineTune:Byte;           { Instrument finetune value 
                                 (not used in Ultimate ST mods) }
      Volume:Byte;             { Instrument volume }
      LStart,                  { Loop START in WORDS (PT,ST,NT,etc.)
                                 or BYTES in Ultimate ST!!!!
                               }
      LLength:Word;            { Loop LENGTH in WORDS }
     end;


procedure jssLoadMOD(var AStream:PStream; var AModule:PJSSModule; AExtra:Pointer);
 const jProcName = 'jssLoadMOD';

 var
    {** General loader variables **}
    MODSongName:String22;    { MOD-name }
    MODH:PMODTypeData;
    MODI:TMODInstrument;     { One temp. instrument for converting
                               MOD instruments to internal format }
    ATempStr:String;
    ATempInt:Longint;
    ATempByte:Byte;

    ATempBufSize:Longint;
    ATempBufData:Pointer;

    ATempCr:Cardinal;

procedure MOD_AllocTempUnpackBuf(ASize:Longint);
begin
 ATempBufSize:= ASize;
 GetMem(ATempBufData, ATempBufSize);
end;

procedure MOD_DeallocTempUnpackBuf;
begin
 if (ATempBufData <> NIL) then
    begin
     FreeMem(ATempBufData, ATempBufSize);
     ATempBufData:= NIL;
     ATempBufSize:= 0;
    end;
end;

procedure MOD_UnpackPattern(ASourceData:Pointer; ASourceSize, ASourceChannels:Longint; var ADestPat:TJSSPattern);
 var
    ASourceOffs,
    ATempVal,
    APatChannel,
    APatRow:Longint;
    AByt0, AByt1,
    AByt2, AByt3:Byte;
    AEffect:Char;

function jssGetByte:Byte;
begin
 jssGetByte:= PByte(ASourceData)^;
 inc(longint(ASourceData));
 inc(ASourceOffs);
end;

function MOD_PeriodToNote(APeriod:Longint):Integer;
 var ANote:Longint;
begin
 MOD_PeriodToNote:= mpNoData;

 for ANote:= jsetMinNote to jsetMaxNote do
 begin
 if (APeriod >= (mpPeriodTable[ANote] - MOD_PeriodTolerance)) and
    (APeriod <= (mpPeriodTable[ANote] + MOD_PeriodTolerance)) then
    begin
     MOD_PeriodToNote:= (ANote - (12*2));
     exit;
    end;
 end;

 writeln('#[', APatRow, '/', APatChannel, ']: ', APeriod, ' = ', round(7159090.5 / (APeriod * 2)), ' Hz');
end;


begin
 {** Check data pointers **}
 if (ASourceData = NIL) then
    begin
     SUP_MAC_CLOSE_STREAM
     MOD_DeallocTempUnpackBuf;
     jssErrorN:= jerrNULLPointer;
     jssError(jProcName, 'Error unpacking pattern. Pattern SOURCE pointer NULL.');
     exit;
    end;

 if (ADestPat.AUsed = FALSE) or
    (ADestPat.AData = NIL) then
    begin
     SUP_MAC_CLOSE_STREAM
     MOD_DeallocTempUnpackBuf;
     jssErrorN:= jerrNULLPointer;
     jssError(jProcName, 'Error unpacking pattern. Pattern DEST pointer NULL.');
     exit;
    end;

 {** Init variables **}
 ASourceOffs:= 0;
 APatRow:= 0;

 {** Pattern unpacking loop **}
 while (APatRow < ADestPat.ARows) and
       (ASourceOffs < ASourceSize) do
 begin
  {** Loop for channels **}
  for APatChannel:= 1 to ASourceChannels do
  with ADestPat.AData^[APatRow, APatChannel] do
  begin
   {** Get four databytes of interest **}
   AByt0:= jssGetByte;
   AByt1:= jssGetByte;
   AByt2:= jssGetByte;
   AByt3:= jssGetByte;

   {** Convert the period value to Notevalue **}
   ATempVal:= ((AByt0 and $0F) shl 8) + AByt1;
   if (ATempVal = 0)
      then Note:= mpNoData
      else Note:= MOD_PeriodToNote(ATempVal);


   {** Get instrument number **}
   Instr:= ((AByt0 and $f0) + (AByt2 shr 4));
   if (Instr = 0) then
      Instr:= mpNoData;

   {** There's no volume column in MOD, so ignore **}
   Volume:= mpNoData;

   {** Get effect & parameter **}
   ATempVal:= (AByt2 and $0f);
   if (ATempVal = 0) and (AByt3 = 0)
      then Effect:= mpNoData
      else Effect:= ATempVal;

   Param:= AByt3;


   {** Do effect conversion for module subtypes **}
   AEffect:= mpMODEffectTable[Effect];

   case MODH^.IFlags of
    jmdiUSTmodule: begin {## Ultimate SoundTracker ##}
                    if (AEffect = '1') then
                       begin
                        Effect:= 0;
                       end else

                    if (AEffect = '2') then
                       begin
                        if ((Param AND $f0) = 0) AND 
                           ((Param AND $0f) > 0) then
                           begin    { 20y -> 10y }
                            Effect:= 1;
                           end else
                        if ((Param AND $0f) = 0) AND
                           ((Param AND $f0) > 0) then
                           begin    { 2x0 -> 20x }
                            Param:= (Param SHR 4);
                           end else
                           begin    { If invalid command/param, clear it! }
                            Effect:= mpNoData;
                            Param:= 0;
                           end;
                       end;
		   end;
   end;

  end;

  inc(APatRow);
 end; { WHILE }
 {** Unpacking OK. **}
end;



function MOD_GetFinetuneC(AFineTune:Byte):Longint;
begin
 case AFineTune of
  0  : MOD_GetFinetuneC:= 8363;
  1  : MOD_GetFinetuneC:= 8413;
  2  : MOD_GetFinetuneC:= 8463;
  3  : MOD_GetFinetuneC:= 8529;
  4  : MOD_GetFinetuneC:= 8581;
  5  : MOD_GetFinetuneC:= 8651;
  6  : MOD_GetFinetuneC:= 8723;
  7  : MOD_GetFinetuneC:= 8757;
  8  : MOD_GetFinetuneC:= 7895;
  9  : MOD_GetFinetuneC:= 7941;
  10 : MOD_GetFinetuneC:= 7985;
  11 : MOD_GetFinetuneC:= 8046;
  12 : MOD_GetFinetuneC:= 8107;
  13 : MOD_GetFinetuneC:= 8169;
  14 : MOD_GetFinetuneC:= 8232;
  15 : MOD_GetFinetuneC:= 8280;
  else MOD_GetFinetuneC:= 8363;
 end;
end;

begin
 {******************** Check for internal inconsistencies ******************}
 if (MOD_MaxChannels > jsetMaxNChannels) or
    (MOD_MaxRows > jsetMaxRows) or
    (MOD_MaxPatterns > jsetMaxPatterns) or
    (MOD_MaxInstruments > jsetMaxInstruments) or
    (MOD_MaxOrders > jsetMaxOrders) then
    begin
     jssErrorN:= jerrInternalError;
     jssError(jProcName, 'Internal inconsistency in JLOADMOD.PAS');
     exit;
    end;

 {******************* Read MOD-header and check data in it *****************}
 {$ifdef OPT_MODDEBUG}
 writeln(' Reading and checking MOD header...');
 {$endif}

 MODH:= AExtra;

 {** Read song name **}
 AStream^.vmGetData(@MODSongName, MOD_SongNameLength);
 if (AStream^.vmStatus <> strOK) then
    begin
     SUP_MAC_FAIL_STREAM
     jssErrorN:= jerrFileReadError;
     jssError(jProcName, 'Error reading songname from stream 0x'+ ioPtr2Hex(AStream));
     if (ioFailOnError) then exit;
    end;

 {************************* Init internal variables ************************}
 {$ifdef OPT_MODDEBUG}
 writeln(' Initializing and allocating MOD module...');
 {$endif}
 if (jssAllocateModule(AModule) <> jerrOK) then
    begin
     SUP_MAC_CLOSE_STREAM
     jssError(jProcName, 'Error allocating new module structure!');
     exit;
    end;

 with AModule^ do
 begin
  ModuleType    := jmdtMOD;
  jssASCIIZToStr(@MODSongName, ModuleName, MOD_SongNameLength);
  ModuleInfo    := MOD_DataString;
  DefSpeed      := 6;
  DefTempo      := 125;
  DefGlobalVol  := 64;
  DefMasterVol  := 32;
  NInstruments  := MODH^.NInstr;
  NChannels     := MODH^.NChannels;
  DefFlags      := (jmdfAmigaPeriods OR jmdfAmigaLimits OR jmdfStereo) OR MODH^.AFlags;
  IntFlags      := MODH^.IFlags;
  IntVersion    := $0315;

  {** Set module panning positions **}
  if (NChannels = 4) then
  begin
   {** Normal 4 channel mod.. use Amiga pannings **}
   DefPanning[1]:= jchPanLeft;
   DefPanning[2]:= jchPanRight;
   DefPanning[3]:= jchPanRight;
   DefPanning[4]:= jchPanLeft;
  end else
  begin
   {** Special > 4 channel, use parity panning **}
   for ATempInt:= 1 to NChannels do
   if ((ATempInt and 1) = 1)
      then DefPanning[ATempInt]:= jchPanLeft
      else DefPanning[ATempInt]:= jchPanRight;
  end;
 end;


 {**************************** Read instruments *****************************}
 {$ifdef OPT_MODDEBUG}
 write(' Reading instrument headers');
 {$endif}
 for ATempInt:= 1 to AModule^.NInstruments do
     begin
      {** Read one instrument to temp structure **}
      AStream^.vmGetData(@MODI, sizeof(TMODInstrument));
      if (AStream^.vmStatus <> strOK) then
         begin
          SUP_MAC_FAIL_STREAM
          jssErrorN:= jerrFileReadError;
          jssError(jProcName, 'Error reading instrument #'+ ioStrL(ATempInt));
          if (ioFailOnError) then exit;
         end;

      {** Allocate and initialize instrument **}
      if (jssAllocateInstrument(AModule^.Instruments[ATempInt]) <> jerrOK) then
         begin
          SUP_MAC_FAIL_STREAM
          jssErrorN:= jerrFileReadError;
          jssError(jProcName, 'Error allocating instrument structure #'+ ioStrL(ATempInt));
          if (ioFailOnError) then exit;
         end;

      with AModule^.Instruments[ATempInt]^ do
      begin
       {** Make rest of data **}
       Filename    := '';
       Size        := (swap(MODI.Size) * 2);
       ByteSize    := Size;
       LStart      := swap(MODI.LStart);
       if (jssGetANYFlag(MODH^.AFlags, jmdfByteLStart) = FALSE)
          then LStart:= (LStart * 2);

       LEnd        := (swap(MODI.LLength) * 2) + LStart;
       Volume      := MODI.Volume;
       C4BaseSpeed := MOD_GetFinetuneC(MODI.FineTune);
       jssASCIIZToStr(@MODI.Description, Description, SizeOf(MODI.Description));
       Data        := NIL;
       Flags       := 0;

       {** Set the "used" flag **}
       if (Size > 0)
          then Used:= TRUE
          else Used:= FALSE;

       {** Make instrument flags **}
       if (Volume > mpMaxVol) then
          Volume:= mpMaxVol;

       if (LEnd > 2) and (Used) then
       begin
        {** Check looped things **}
        Flags:= (Flags OR jsfLooped);

        if (LEnd > Size) then
           begin
            jssWarning(jProcName, 'Instrument #'+ ioStrL(ATempInt)+' has loop-end > sample-length!');
            LEnd:= Size;
           end;

        if (LStart > LEnd) then
           begin
            jssWarning(jProcName, 'Instrument #'+ ioStrL(ATempInt)+' has loop-end > loop-start!');
            LEnd:= Size;
           end;
       end;
      end;
      {$ifdef OPT_MODDEBUG}
      write('.');
      {$endif}
 end;

 {************************* Read pattern orderlist *************************}
 {$ifdef OPT_MODDEBUG}
 writeln;
 writeln(' Reading orders...');
 {$endif}
 with AModule^ do
 begin
  {*** Get the orders list and number of orders ***}
  NOrders:= AStream^.vmGetByte;   { Read number of orders }

  if (NOrders > MOD_MaxOrders) then
     begin
      jssWarning(jProcName, 'Too many orders ('+ ioStrL(NOrders)+') when max is '+ ioStrL(MOD_MaxOrders));
      NOrders:= MOD_MaxOrders;
     end;

  { UST modules have default Tempo, for others this is just a dummy byte. }
  if (MODH^.IFlags = jmdiUSTmodule)
     then DefTempo:= AStream^.vmGetByte
     else AStream^.vmGetByte;

  {** Read orderlist **}
  for ATempInt:= 0 to (MOD_MaxOrders - 1) do
  begin
   ATempByte:= AStream^.vmGetByte;
   OrderList[ATempInt]:= ATempByte;
   if (AStream^.vmStatus <> strOK) then
      begin
       SUP_MAC_FAIL_STREAM
       jssErrorN:= jerrFileReadError;
       jssError(jProcName, 'Error reading MOD orders list order #'+ ioStrL(ATempInt));
       if (ioFailOnError) then exit;
      end;
  end;

  {*** Scan the orderlist to get the number of patterns ***}
  NPatterns:= 0;
  for ATempInt:= 0 to (NOrders - 1) do
      begin
       { Check if it's larger than largest found }
       ATempByte:= OrderList[ATempInt];
       if (integer(ATempByte) > NPatterns) then
          NPatterns:= ATempByte;
      end;

  inc(NPatterns);

  if (NPatterns > MOD_MaxPatterns) then
     begin
      jssWarning(jProcName, 'Too many patterns ('+ ioStrL(NPatterns)+') when max is '+ ioStrL(MOD_MaxPatterns));
      NPatterns:= MOD_MaxPatterns;
     end;
 end;

 {***************************** Read patterns ******************************}
 ATempCr:= AStream^.vmGetPos;
 AStream^.vmGetData(@ATempStr, 4); { Ignore subtype string }
 {$ifdef OPT_MODDEBUG}
 writeln;
 write(' Reading pattern data');
 {$endif}

 {** Read and unpack patterns **}
 for ATempInt:= 0 to (AModule^.NPatterns - 1) do
     begin
      {** Read the packded pattern data from file **}
      MOD_AllocTempUnpackBuf(4 * MOD_MaxRows * AModule^.NChannels);

      AStream^.vmGetData(ATempBufData, ATempBufSize);
      if (AStream^.vmStatus <> strOK) then
         begin
          if (ioFailOnError) then
             begin
              SUP_MAC_CLOSE_STREAM
              MOD_DeallocTempUnpackBuf;
             end;
          jssErrorN:= jerrFileReadError;
          jssError(jProcName, 'Error reading pattern data for #'+ ioStrL(ATempInt));
          if (ioFailOnError) then exit;
         end;

      {** Allocate new pattern and unpack patterndata **}
      if (jssAllocatePattern(AModule^.Patterns[ATempInt], MOD_MaxRows) <> jerrOK) then
         begin
          if (ioFailOnError) then
             begin
              SUP_MAC_CLOSE_STREAM
              MOD_DeallocTempUnpackBuf;
             end;
          jssError(jProcName, 'Error allocating pattern data for #'+ ioStrL(ATempInt));
          exit;
         end;

      MOD_UnpackPattern(ATempBufData, ATempBufSize,
                        AModule^.NChannels, AModule^.Patterns[ATempInt]);

      MOD_DeallocTempUnpackBuf;
      {$ifdef OPT_MODDEBUG}
      write('.');
      {$endif}
     end;

 {$ifdef OPT_MODDEBUG}
 writeln;
 {$endif}

 {**************************** Read instruments *****************************}
 {$ifdef OPT_MODDEBUG}
 write(' Reading instrument data');
 {$endif}
{
 AStream^.vmSeek(ATempCr + (AModule^.NPatterns * 4 * AModule^.NChannels * 64));
}

 for ATempInt:= 1 to AModule^.NInstruments do
 with AModule^.Instruments[ATempInt]^ do
 if (Used) then
     begin
      {** Allocate the memory **}
      GetMem(Data, ByteSize);
      if (Data = NIL) then
         begin
          SUP_MAC_CLOSE_STREAM
          jssErrorN:= jerrMemAllocError;
          jssError(jProcName, 'Memory allocation error for sample #'+ ioStrL(ATempInt));
          exit;
         end;

      {** Read the sampledata **}
      AStream^.vmGetData(Data, ByteSize);
      if (AStream^.vmStatus <> strOK) then
         begin
          SUP_MAC_FAIL_STREAM
          jssErrorN:= jerrFileReadError;
          jssError(jProcName, 'Error reading sample data #'+ ioStrL(ATempInt));
          if (ioFailOnError) then exit;
         end;

      {** Convert sample to UNSigned format **}
      jssFlipSampleSign8(Data, ByteSize);

      {$ifdef OPT_MODDEBUG}
      write('.');
      {$endif}
     end;

 {$ifdef OPT_MODDEBUG}
 writeln;
 {$endif}

 SUP_MAC_CLOSE_STREAM
end;


function jssDetectMOD(AStream:PStream; var AExtra:Pointer):Longint;

{ "Analyze" a given string for possibility of being
  a real "human readable" text. Very simple, but
  may work sometimes.
}
function jssAnalyzeASCIIStr(AStr:String):Boolean;
 var AIndex, ACount, ALength:Longint; AResult:Boolean;
begin
 AResult:= FALSE;
 ACount:= 0; 
 AStr:= ioLowerCase(AStr);
 ALength:= length(AStr);
 if (ALength > 0) then
    begin
     { Check for ASCII characters }
     for AIndex:= 1 to ALength do
     if (AStr[AIndex] in ['a'..'z',#32,'-','+','.',',','0'..'9','?'])
        then inc(ACount);

     { If over 50% were ASCII or whitespaces, increase probability }     
     if ((ACount / ALength) > 0.5) then
        AResult:= TRUE;

     { Check for "ST-??:" text in samplename }
     if ((Copy(AStr, 1, 3) = 'st-') AND
         (AStr[6] = ':'))
         then AResult:= TRUE;
    end;
    
 jssAnalyzeASCIIStr:= AResult;
end;

 var
    AResult, ATempRes1,
    ATempRes2, ATempRes3,
    ATempInt, ATempI2:Longint;
    ATempBool:Boolean;
    ATempModName,
    ATempStr:String;
    MODSongName:String22;
    MODI:TMODInstrument;
begin
 AResult:= -2;
 AExtra:= NIL;
 
 {** Try to read the ident-tag **}
 AStream^.vmSeek(1080);
 AStream^.vmGetData(@ATempStr[1], 4);
 if (AStream^.vmStatus <> strOK) then exit(-2);
 ATempStr[0]:= chr(4);

 {** Read song name **}
 AStream^.vmSeek(0);
 AStream^.vmGetData(@MODSongName, MOD_SongNameLength);
 if (AStream^.vmStatus <> strOK) then exit(-2);

 jssASCIIZToStr(@MODSongName, ATempModName, MOD_SongNameLength);

 {** Check through known MOD subtypes **}
 ATempBool:= false;
 ATempInt:= 1;
 while (ATempInt <= jsetMODTypes) and
       (ATempBool = FALSE) do
       begin
        if (jsetMODTypeIdents[ATempInt].AIdent = ATempStr)
        then ATempBool:= TRUE
        else inc(ATempInt);
       end;
       
 {** Check if we have got a match **}
 if (ATempBool) then
    begin
     {** We have a match **}
     inc(AResult, 2);
     
     { Analyze module name string }
     if (jssAnalyzeASCIIStr(ATempModName))
        then inc(AResult, 1);
     
     {** Set the MODH info **}
     AExtra:= @jsetMODTypeIdents[ATempInt];
    end else
    begin
     { 
       Try to use a very simple "heuristic" algorithm to
       identify really old no-tag MODs...
       
       1) Analyze module name string
       2) Analyze instrument headers
          - Load 15 instruments (there are always at least 15!)
          - Analyze for proper values, and for UST modules
       3) 
     }
     ATempRes1:= -45; { 15-chan MOD probability }
     ATempRes2:= -35; { UST MOD probability }
     
     {!! Analyze module name string }
     if (jssAnalyzeASCIIStr(ATempModName))
        then inc(ATempRes1, 6);
     
     {!! Analyze instrument headers }
     for ATempInt:= 1 to 15 do
     begin
      {** Read one instrument to temp structure **}
      AStream^.vmGetData(@MODI, sizeof(TMODInstrument));
      if (AStream^.vmStatus <> strOK) then exit(-2);

      {** Analyze basic information **}
      ATempRes3:= 0;
      { Check for legal values in ST/PT sample loop settings }
      if (((MODI.LStart + MODI.LLength) <= MODI.Size) AND
          (MODI.Size > 0)) then
         inc(ATempRes3, 1);

      { Check for legal Volume value }
      if (MODI.Volume <= 64) then
         inc(ATempRes3, 1);

      { Check for legal FineTune value }
      if (MODI.FineTune >= 0) and
         (MODI.FineTune <= 15) then
         inc(ATempRes3, 1);

      { Analyze instrument name field }
      jssASCIIZToStr(@MODI.Description, ATempStr, SizeOf(MODI.Description));
      if (jssAnalyzeASCIIStr(ATempStr)) then
         inc(ATempRes3, 2);

      { If per/instrument result is >= 3, we add up additional 3! }
      if (ATempRes3 >= 3) then inc(ATempRes3, 3);
      
      { Add to final result ATempRes1 }
      inc(ATempRes1, ATempRes3);

      
      {** Analyze for UST MOD **}
      { Check for ILLEGAL values (illegal in PT/ST) of
        instrument loop settings 
      }
      if (((MODI.LStart + MODI.LLength) > MODI.Size) AND
         (MODI.Size > 0)) then
         inc(ATempRes2, 2);
      
      { Check for maximum sample length (9999 bytes) }   
      if ((MODI.Size <= $1387) AND (MODI.Size > 0)) then
         inc(ATempRes2, 2);
     end;


     {** Do the final decisions **}
     if (ATempRes1 > 0) then
     begin
      {** Very probably we have a ST/PT module **}
      { Increase probability }
      inc(AResult, 1);
      
      if (ATempRes1 > 10) then
         inc(AResult, 2);
      
      { Put MOD loaderinfo in place }
      AExtra:= @jsetMODTypeIdents2[1];
      
      {** Do we have a UST module ? **}
      if (ATempRes2 > 0) then
      AExtra:= @jsetMODTypeIdents2[2];
     end;
    end;


 {** Check other things that might be relevant **}
 AStream^.vmSeek(950);
 ATempInt:= AStream^.vmGetByte;
 ATempI2:= AStream^.vmGetByte;

 if (ATempInt >= 1) AND
    (ATempInt <= 128) then
    inc(AResult);

 if (ATempInt = 127) then inc(AResult);
     
 {** Result **}
 if (AExtra <> NIL) then
 with PMODTypeData(AExtra)^ do
 writeln('detectmod: ["', AIdent, '"/', NChannels, ':', NInstr, '] res=', AResult, ', tres1=', ATempRes1, ', tres2=', ATempRes2);
 jssDetectMOD:= AResult; 
end;

{$endif} { GET_IMPLEMENTATION }

