{
 ljPL version 0.5x - The Next Mutation

 This is just the good'ol ljpl, transforming to use the first
 beta release of JSS (when it comes), aka file-streams, etc.

 CURRENTLY CONTAINS SOME MAJOR AND MINOR HACKS!

 TODO:
 - terminal type user interface.
 - GUI?
 - more options?
}
program LJPL;

 uses
      Linux,
      BaseAPI,
      JSS,
      JSSMod,
      JSSPlr;

 const
      {** General constants **}
      vmProgName    = 'jPL';          { Program name }
      vmVersion     = '0.49.4';       { and version }
      vmMessage     = vmProgName +' v'+ vmVersion + ioCopyright;

      vmBits:Array[Boolean] of String[2] = ('8', '16');
      vmStereo:Array[Boolean] of String[6] = ('mono', 'stereo');
      vmInterpol:Array[Boolean] of String[15] = ('normal', 'interpolated');

      vmNoteTable:Array[0..11] of String[2] =
      ('C-', 'C#', 'D-',
       'D#', 'E-', 'F-',
       'F#', 'G-', 'G#',
       'A-', 'A#', 'B-');

      {** Options & default settings **}
      SET_ModuleName:String   = '';     { Default module filename }
      SET_DebugMode:Boolean   = FALSE;  { Use debug mode }
      SET_StartOrder:Longint  = 0;      { Starting "order" }
      SET_Opt_Loop:Boolean    = TRUE;   
      SET_Opt_Jumps:Boolean   = TRUE;
      SET_Interface:Boolean   = FALSE; 
      SET_Verbose:Boolean     = FALSE;
      SET_MuteChannelsS:Longint = 0;
      SET_ADev_DSP:String     = '';     { Sound Device filename }

 var
    SET_MuteChannels:Array[jsetMinChannel..jsetMaxChannel] of Boolean;
    AModule:PJSSModule;
    APlayer:PJSSModulePlayer;
    ASaveExitProc:Pointer;
    ADevice:PJSSSoundDevice;
    AConfig:TJSSConfigFile;
    ATempStr:PStream;
    AExtra:Pointer;

procedure jplParseCommandline;

procedure jplParseOption(AOption:String);
 var
    ATempI, ACode, APos:Longint;
    ASetting:Boolean;
    ATempS:String;
begin
 ASetting:= (AOption[length(AOption)] <> '-');

 case AOption[2] of
  'd': SET_DebugMode:= ASetting;
  
  'f': begin
        val(ioCopyFrom(AOption,3), AConfig.SOutFreq, ACode);
        if (ACode < 0) OR (AConfig.SOutFreq <= 0) then
        ioInternalError(vmProgName, 'Invalid starting order option "'+ AOption +'".');
       end;

  '1': AConfig.SOutMode16bit:= TRUE;
  '8': AConfig.SOutMode16bit:= FALSE;
  's': AConfig.SOutModeStereo:= TRUE;
  'm': AConfig.SOutModeStereo:= FALSE;
       
  'j': SET_Opt_Jumps:= ASetting;
  'l': SET_Opt_Loop:= ASetting;

  'i': SET_Interface:= ASetting;

  'o': begin
        val(ioCopyFrom(AOption,3), SET_StartOrder, ACode);
        if (ACode < 0) then
        ioInternalError(vmProgName, 'Invalid starting order option "'+ AOption +'".');
       end;

  'c': begin
        { Check the suboption }
        case AOption[3] of
         'o': SET_MuteChannelsS:= 1; 
         'm': SET_MuteChannelsS:= 2;
         else ioInternalError(vmProgName, 'Invalid sub-option for -c<X>[channels] ('+ AOption +')');         
        end;
        
        { Parse the given channel numbers }
        APos:= 4;
        while (APos <= length(AOption)) do
        begin
         ATempS:= ioGetNextItem(AOption, APos, [',', ':']);
         val(ATempS, ATempI, ACode);
        
         if (ACode < 0) or (ATempI < jsetMinChannel) or (ATempI > jsetMaxChannel) then
            ioInternalError(vmProgName, 'Invalid channel option "'+ AOption +'".');

         SET_MuteChannels[ATempI]:= TRUE;         
         inc(APos);
        end;
       end;

  'h': begin
{$ifndef Unix}
        writeln('Oh, you think that you are using some Unix? Ehh? ;)');
{$endif}
        SET_ADev_DSP:= ioCopyFrom(AOption, 3);
       end;

  else ioInternalError(vmProgName, 'Invalid option "'+ AOption +'".');
 end;
end;

 var
    AParameter:String;
    NParameter:Integer;

begin
 NParameter:= 1;
 while (NParameter <= ParamCount) do
 begin
  AParameter:= ParamStr(NParameter);
  if (AParameter[1] <> '-') then
     begin
      if (SET_ModuleName = '') then
         SET_ModuleName:= AParameter else
         ioInternalError(vmProgName, 'Too many filename-parameters in commandline!');
     end else
      jplParseOption(AParameter);

  inc(NParameter);
 end;
end;

procedure jplShowNote(APattern:TJSSPattern; ARow, AChannel:Longint);
begin
  if (APattern.AUsed = FALSE) or (APattern.AData = NIL) then exit;

  with APattern.AData^[ARow, AChannel] do
  begin
   case Note of
    mpNoData:  write('... ');
    mpNoteOff: write('--- ');
    else       write(vmNoteTable[Note mod 12], ioStrW(Note div 12), ' ');
   end;

   if (Instr <> mpNoData)
      then write(ioStrL0(Instr, 2), ' ')
      else write('.. ');

   if (Volume <> mpNoData)
      then write(ioStrL0(Volume, 2), ' ')
      else write('.. ');

   if (Effect <> mpNoData)
      then write(char(64 + Effect))
      else write('.');

   if (Effect <> mpNoData)
      then write(ioHexB(Param))
      else write('..');

   write('|');
 end;
end;

procedure jplExitProc;
begin
 {** Check for error **}
 if (ExitCode <> 0) or
    (SET_DebugMode) then
    begin
     writeln('o ExitCode: ', ExitCode);
     writeln('o General error information:');
     writeln('  JSS errorcode: ', jssErrorN, ' [0x', ioHexW(jssErrorN), ']');
     if (APlayer <> NIL) then
        with APlayer^ do
	begin
        writeln('  Order=', mpOrder, ', pat=', mpPattern, ', row=', mpRow,
                ', chan=', mpChannel, ' [tick=', mpTick, '/', mpSpeed, ' : tempo=', mpTempo, ']');

	if (AModule <> NIL) AND (mpPattern >= 0) then
	begin
	 write('  TrackNote: ');
	 jplShowNote(AModule^.Patterns[mpPattern], mpRow, mpChannel);
	 writeln;
	end;
	end;

     if (ADevice <> NIL) then
        with ADevice^ do
        begin
        writeln('  Device=', SDevice, ', baseport=0x', ioHexW(SBase),
                ', irq=', SIRQ, ', dma=', SDMA);
        writeln('  Freq=', SOutFreq, ' Hz, gvol=', SGlobalVol, ', chn=', SNChannels);
        end;
    end;

 {** Do some de-initializations **}
 if (APlayer <> NIL) then
    begin
     writeln('o Close player.');
     dispose(APlayer, vmClose);
     APlayer:= NIL;
    end;

 if (ADevice <> NIL) then
    begin
     writeln('o Close sound device.');
     dispose(ADevice, vmClose);
     ADevice:= NIL;
    end;

 if (AModule <> NIL) then
    begin
     writeln('o Dispose module.');
     jssDisposeModule(AModule);
     AModule:= NIL;
    end;

 writeln('o jssClose(): ', jssClose);

 if (SET_Interface) then
 if (ioClose <> ioerrOK) then
    writeln('o Error closing libBaseAPI!');

 ExitProc:= ASaveExitProc;
end;


procedure jplMsgProc(AFrom, AWhat:String);
begin
 if (SET_Verbose) then
 writeln('- ', AFrom, ': ', AWhat);
end;

procedure jplSMsgProc(AFrom, AWhat:String);
begin
 if (SET_Verbose) then
 write('- ', AFrom, ': ', AWhat);
end;

procedure jplWarningProc(AFrom, AMessage:String);
begin
 writeln('- ', AFrom, ': !WARNING! - ', AMessage);
end;

procedure jplErrorProc(AFrom, AMessage:String);
begin
{
 ioInternalError(AFrom, AMessage);
}
 halt(2);
end;


procedure jplSigHandler(ASignal:Longint); cdecl;
begin
 writeln;
 write(vmProgName, ': Signal #', ioStrL(ASignal), ' received (To PID #', GetPid, '): SIG ');
 case ASignal of
  SIGINT:  writeln('INT');
  SIGSEGV: begin
            writeln('SEGV');
            halt;
           end;
  SIGHUP:  writeln('HUP');
  SIGQUIT: writeln('QUIT');
  SIGTERM: writeln('TERM');
  else begin
        writeln('???');
        halt;
       end;
 end;

 halt(ASignal);
end;

 var ATempI, AModuleLoader:Longint;

begin
 {** Initialize program **}
 ASaveExitProc:= ExitProc;
 ExitProc:= @jplExitProc;
 jssMsg:= @jplMsgProc;
 jssMsgS:= @jplSMsgProc;
 jssWarning:= @jplWarningProc;

 jssError:= @jplErrorProc;


 AModule:= NIL;
 APlayer:= NIL;
 ADevice:= NIL;

 for ATempI:= jsetMinChannel to jsetMaxChannel do
     SET_MuteChannels[ATempI]:= FALSE;
     
 {** Initialize signal handlers **}
 Signal(SIGHUP, @jplSigHandler);
 Signal(SIGINT, @jplSigHandler);
 Signal(SIGQUIT, @jplSigHandler);
{
 Signal(SIGSEGV, @jplSigHandler);
}
 Signal(SIGTERM, @jplSigHandler);

 {** Set the predefined configuration **}
 with AConfig do
 begin
  SDevice         := sdOSS;
  SBase           := -1;
  SIRQ            := -1;
  SlDMA           := -1;
  ShDMA           := -1;
  SOutMode16bit   := TRUE;
  SOutModeStereo  := FALSE;
  SOutFreq        := 44100;
  SMixInterpolate := FALSE;
 end;


 {** Show the help & startup texts **}
 writeln;
 writeln(vmMessage);
 writeln(jssMessage);
 if (ParamCount = 0) then
    begin
     writeln('Usage: ', ParamStr(0), ' [options] <module[.ext]>');
     writeln('Available module loaders:');
     for ATempI:= 1 to jssGetLoaders do
         writeln('  ', jssGetLoaderInfo(ATempI));

     writeln('Options:');
     writeln('-d      : Debugging mode.');
     writeln('-v      : Verbose mode.');
     writeln('-i      : Interactive user interface (not implemented)');

     writeln('-h<x>   : Set DSP device filename to <x>');
     writeln('-f<x>   : Set output/mixing frequency.');
     writeln('-8/-16  : Set 8- or 16-bit output.');
     writeln('-m/-s   : Set mono- or stereo-output.');
     
     writeln('-l[+/-] : Enable/disable looping of module.');
     writeln('-j[+/-] : Enable/disable jump commands (pat jump/pat break).');
     writeln('-o<x>   : Set start order.');
     writeln('-co<x>  : Output only specified channel numbers.');
     writeln('          Multiple channels can be specified: -cox,x,...,x');
     writeln('-cm<x>  : Mute specified channel numbers. Opposite of -co.');
     writeln('          Multiple channels can be specified: -cmx,x,...,x');
     halt;
    end;


 {** Parse the commandline **}
 jplParseCommandline;

 if (SET_Interface) then
 begin
  writeln('o NOTICE! User interface is EXPERIMENTAL <enter>');
  readln;
 end;

 {** Initialize libBaseAPI **}
 if (ioInit <> ioerrOK) then 
    begin
     writeln(vmProgName +': Error occured while trying to initialize libBaseAPI.');
     halt(255);
    end;

 {** Initialize J Sound System **}
 writeln('o jssInit(): ', jssInit);
 with AConfig do
 begin
  writeln('  ', vmBits[SOutMode16bit], '-bit ', vmStereo[SOutModeStereo], ' output.');
  writeln('  ', vmInterpol[SMixInterpolate], ' mixing with ', SOutFreq, ' Hz frequency.');
 end;

 {** Load the module file **}
 writeln('o Opening module file stream: ', SET_ModuleName);

 { Buffered version disabled until the reliability of PStream class has been proven clearly enough!
 ATempStr:= new(PBufferedFileStream, vmOpen(SET_ModuleName, ioOpen_RdOnly, 128*1024));
 }
 ATempStr:= new(PFileStream, vmOpen(SET_ModuleName, ioOpen_RdOnly, TRUE));
 if (ATempStr = NIL) then
    ioInternalError(vmProgName, 'Error allocating/opening stream.');

 AModuleLoader:= jssDetectModule(ATempStr, AExtra);
 writeln('o Autodetected: ', jssGetLoaderName(AModuleLoader));

 writeln('o Loading module ...');
 jssLoadModule(AModuleLoader, ATempStr, AModule, AExtra);
 if (AModule = NIL) then
    ioInternalError(vmProgName, 'Error loading module.');

 dispose(ATempStr, vmClose);
  
 {** Initialize sound device **}
 writeln('o Initializing sound device...');
 case AConfig.SDevice of

  sdOSS:              ADevice:= new(PJD_OSS, vmInit(AConfig, SET_ADev_DSP));
{
  sdSoundBlaster:     ADevice:= new(PJD_SoundBlaster, vmInit(AConfig));
  sdGravisUltrasound: ADevice:= new(PJD_GravisUltrasound, vmInit(AConfig));
}
 end;

 if (ADevice = NIL) then
    halt(2);

 {** Allocate and initialize player **}
 writeln('o Initializing player...');
 case jssGetLoaderType(AModuleLoader) of

  jmdtS3M: APlayer:= new(PJP_S3MPlayer, vmInit(ADevice));
{
  jmdtPSM: APlayer:= new(PJP_PSMPlayer, vmInit(ADevice));
}
  jmdtMOD: APlayer:= new(PJP_MODPlayer, vmInit(ADevice));

  jmdtPTM: APlayer:= new(PJP_PTMPlayer, vmInit(ADevice));

  jmdtXM:  APlayer:= new(PJP_XMPlayer, vmInit(ADevice));

  else ioInternalError(vmProgName, 'Format is known and loaded, but there is NO PLAYER for it. :)');
 end;


 {** Start playing **}
 writeln('o PLAYING... Please wait...');
 
 APlayer^.mpSetModule(AModule);
 APlayer^.mpSetOptions(moptAllowJumps OR moptLoopModule);
 APlayer^.mpPlayOrder(SET_StartOrder);


 {** Disable channels **}
 case SET_MuteChannelsS of
  0: ;
  
  1: begin
      for ATempI:= jsetMinChannel to jsetMaxChannel do
          ADevice^.vmMuteChannel(ATempI, SET_MuteChannels[ATempI]);
     end;

  2: begin
      for ATempI:= jsetMinChannel to jsetMaxChannel do
          ADevice^.vmMuteChannel(ATempI, (NOT (SET_MuteChannels[ATempI])));
     end;

  else ioInternalError(vmProgName, 'Internal error #foobar.');
 end;
 
 { Now execute the disk playing device }
 ADevice^.vmSetGlobalVol(64);


 write('<enter to stop>'); readln;

 {** So when user hits enter, we quit **}
 { The player and device get closed in exitproc,
   where all the shutdown things are done.
   
   I think that this is the Right Way since
   they at least should get closed in error
   situations too...

   (kill -9 probably fucks it up)
 }
{
 writeln('o OK.');
 writeln('o Playing time: ', int(ADevice^.STimer / (ADevice^.SOutFreq * 60)):1:0,
 ':', (frac(ADevice^.STimer / (ADevice^.SOutFreq * 60)) * 60):1:0, ' ??');
}
end.
